

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ToastController, ModalController, App} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {CalendarModal, CalendarModalOptions, CalendarResult} from "ion2-calendar";
import {OfficePage} from '../office/office';
/**
 * Created By : ZULQANI FAUZI
 * Created Date : 23/07/2018
 * Updated Date : 24/07/2018
 */

@IonicPage()
@Component({
  selector: 'page-expired',
  templateUrl: 'expired.html',
})
export class ExpiredPage {
resposeData: any;
    recartDataBPG: any;
    dataProduct: any;
    noRecords: boolean = false;
    userDetails: any;
    cartDataBPG: any;
    results: any;
    total_item: number;
    userPostData = {
        nama_depan: "",
        nama_belakang: "",
        id_member: ""
    };
    tiba: Date;
    userCartBPG = {
        pengembalian:"",
        cart_id:"",
        cart_item_id:"",
        type_cart: "",
        TransID: "",
        WHSIDFrom: 0,
        WHSIDTo: 0,
        BTBID: "",
        BPGRequestID: "",
        Remark: "",
        RemarkDtl:"",
        UserID: "",
        username: "",
        ItemID: "",
        ProductionDate: "",
        Qnty: 0,
        quantity:0,
        product_id:""
    }
    items: any[] = [];
    itemsDetail: any[] = [];

    constructor(public navCtrl: NavController, public navParams: NavParams,
        public modalCtrl: ModalController,
        public authService: AuthService,
        public app: App,
        public alertCtrl: AlertController,
        private toastCtrl: ToastController) {
        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userCartBPG.UserID = this.userDetails.username;
        this.userCartBPG.username = this.userDetails.username;
        this.userCartBPG.type_cart = "4";
        this.userCartBPG.Remark = "";
        this.getStock();
        this.getStockDetail();
        this.getCart();
    }
    getStock() {
        this.authService.postData(this.userPostData, "getTransaksiBPGHdr").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.prodData) {
                    this.dataProduct = this.resposeData.prodData;
                    for (let i = 0; i < this.resposeData.prodData.length; i++) {
                        let a = this.resposeData.prodData[i].ItemID;
                        let b = this.resposeData.prodData[i].ItemName;
                        this.items.push({
                            "ItemID": a,
                            "ItemName": b
                        });
                    }
                } else {
                    this.presentToast("Gagal terhubung ke server.");
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    getStockDetail() {
        this.authService.postData(this.userPostData, "getTransaksiBPG").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.bpgData) {
                    this.dataProduct = this.resposeData.bpgData;
                    for (let i = 0; i < this.resposeData.bpgData.length; i++) {
                        let WHSID = this.resposeData.bpgData[i].WHSID;
                        let tglTerima = this.resposeData.bpgData[i].WHSApprovalDate;
                        let ItemID = this.resposeData.bpgData[i].ItemID;
                        let Qnty = this.resposeData.bpgData[i].QntyAvailable;
                        let UOMName = this.resposeData.bpgData[i].UOMName;
                        let ItemName = this.resposeData.bpgData[i].ItemName;
                        let ProductionDate = this.resposeData.bpgData[i].ProductionDate;

                        this.itemsDetail.push({
                            "WHSIDFrom": WHSID,
                            "WHSIDTo" : 1,
                            "BTBID":'',
                            "BPGRequestID":'',
                            "UserID": this.userCartBPG.UserID,
                            "tglTerima": tglTerima,
                            "ItemID": ItemID,
                            "ItemName": ItemName,
                            "Qnty": Qnty,
                            "UOMName":UOMName,
                            "ProductionDate":ProductionDate,
                        });

                    }
                } else {
                    this.presentToast("Gagal terhubung ke server.");
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertCartBPG($data) {
        this.userCartBPG.type_cart = "4";
        this.userCartBPG.TransID = "";
        this.userCartBPG.ItemID = $data.ItemID;
        this.userCartBPG.WHSIDFrom = $data.WHSIDFrom;
        this.userCartBPG.WHSIDTo = $data.WHSIDTo;
        this.userCartBPG.BTBID = $data.BTBID;
        this.userCartBPG.BPGRequestID = $data.BPGRequestID;
        this.userCartBPG.ProductionDate = $data.ProductionDate;
        this.userCartBPG.Remark = "";
        this.userCartBPG.Qnty = $data.Qnty;
        this.userCartBPG.RemarkDtl = "BPG Expired Kara Island Gandaria City"
        console.log(this.userCartBPG);
        if (this.userCartBPG.ItemID) {
            this.authService.postData(this.userCartBPG, "insertCartBPG").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                        this.cartDataBPG = this.resposeData.cartData;
                        this.total_item = this.cartDataBPG.length;
                        setTimeout(() => {
                        }, 150);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.presentToast("Gagal mengambil produk.");
        }

    }

    getCart() {
        this.userCartBPG.type_cart = "4";
        this.authService.postData(this.userCartBPG, "getCart").then(
            result => {
                this.recartDataBPG = result;
                if (this.recartDataBPG.cartData) {
                    this.cartDataBPG = this.recartDataBPG.cartData;
                    this.userCartBPG.cart_id = this.cartDataBPG[0].cart_id;
                    this.total_item = this.cartDataBPG.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    updateCart($value) {
        this.userCartBPG.cart_item_id = $value.cart_item_id;
        this.userCartBPG.quantity = $value.quantity;
        this.userCartBPG.ItemID = $value.ItemID;
        this.authService.postData(this.userCartBPG, "updateCart").then(
            result => {
                this.recartDataBPG = result;
                if (this.recartDataBPG.cartData) {
                    this.cartDataBPG = this.recartDataBPG.cartData;
                    this.total_item = this.cartDataBPG.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    deleteCart($value) {
        this.userCartBPG.cart_item_id = $value.cart_item_id;
        this.userCartBPG.Qnty = $value.Qnty;
        this.userCartBPG.ItemID = $value.product_id;
        this.authService.postData(this.userCartBPG, "deleteCart").then(
            result => {
                this.recartDataBPG = result;
                if (this.recartDataBPG.cartData) {
                    this.cartDataBPG = this.recartDataBPG.cartData;
                    this.total_item = this.cartDataBPG.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertBPG() {
        this.authService.postData(this.userCartBPG, "getCart").then(
            result => {
                this.recartDataBPG = result;
                if (this.recartDataBPG.cartData) {
                    this.cartDataBPG = this.recartDataBPG.cartData;
                    this.userCartBPG.cart_id = this.cartDataBPG[0].cart_id;
                    if (this.userCartBPG.cart_id) {
                    console.log(this.userCartBPG);
                        this.authService.postData(this.userCartBPG, "insertBPG").then(
                            result => {
                                this.doAlert();
                                this.app.getRootNav().setRoot(OfficePage);
                            },
                            err => {
                                this.presentToast("Gagal terhubung ke server.");
                            }
                        );
                    } else {
                        this.presentToast("Gagal mengambil produk.");
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    doAlert() {
        let alert = this.alertCtrl.create({
            title: 'Sukses',
            subTitle: 'Konfirmasi penerimaan telah berhasil.',
            buttons: ['Ok']
        });

        alert.present();
    }

    setItems() {
        this.items;
        this.itemsDetail;
    }

    onClear() {
        return this.getStock();
    }
    onCancel() {
        return this.getStock();
    }

    onInput(ev: any) {
        this.setItems();
        let val = ev.target.value;

        if (val && val.trim() !== '') {
            this.items = this.items.filter(function (item) {
                return item.ItemName.toLowerCase().includes(val.toLowerCase());
            });
        }
    }

    openCalendar() {
        const options: CalendarModalOptions = {
            canBackwardsSelected: true,
            title: 'Pilih Tanggal',
            defaultDate: new Date()
        };

        let myCalendar = this.modalCtrl.create(CalendarModal, {
            options: options
        });

        myCalendar.present();

        myCalendar.onDidDismiss((date: CalendarResult, type: string) => {
            if (date === null) {
                this.userCartBPG.pengembalian = this.userCartBPG.pengembalian;
            } else {
                this.userCartBPG.pengembalian = date.string;
            }
        });
    }

    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }